package cokr.xit.fims.cmmn.dao;

import java.util.List;
import java.util.Map;

import org.egovframe.rte.psl.dataaccess.mapper.Mapper;

import cokr.xit.foundation.component.AbstractMapper;
import cokr.xit.foundation.data.DataObject;
import cokr.xit.fims.cmmn.CrdnSttsHstry;
import cokr.xit.fims.cmmn.CrdnSttsHstryQuery;

/** 단속 상태 이력 정보 DAO
 *
 * <p>상세 설명:
 *
 * <pre>
 * ============ 변경 이력 ============
 * 2023-07-19	JoJH 최초 작성
 * ================================
 * </pre>
 */
@Mapper("crdnSttsHstryMapper")
public interface CrdnSttsHstryMapper extends AbstractMapper {
	/**지정한 조건에 따라 단속 상태 이력 목록을 조회하여 반환한다.<br />
	 * @param req 단속 상태 이력 조회 조건
	 * @return 단속 상태 이력 목록
	 */
	List<DataObject> selectCrdnSttsHstryList(CrdnSttsHstryQuery req);

	/**지정한 조건에 따라 단속 상태 이력 객체들을 반환한다.
	 * @param req 단속 상태 이력 조회 조건
	 * @return 단속 상태 이력 객체 목록
	 */
	List<DataObject> selectCrdnSttsHstrys(CrdnSttsHstryQuery req);

	/**지정한 조건에 따라 단속 상태 이력 객체의 마지막 1개를 반환한다.
	 * @param crdnId 단속 ID
	 * @return 지정한 단속 ID의 단속 상태 이력 객체
	 */
	default DataObject selectCrdnSttsHstryInfo(String crdnId, String crdnSttsCd) {
		CrdnSttsHstryQuery req = new CrdnSttsHstryQuery();

		req.setCrdnId(crdnId);
		req.setCrdnSttsCd(crdnSttsCd);
		req.setOrderBy("REG_DT DESC, STTS_HSTRY_ID DESC");

		List<DataObject> crdnSttsHstryList = selectCrdnSttsHstrys(req);

		return !crdnSttsHstryList.isEmpty() ? crdnSttsHstryList.get(0) : null;
	}

	/**단속 상태 이력 정보를 등록한다.
	 * @param params 파라미터
	 * <ul><li>"crdnSttsHstry" - 단속 상태 이력</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int insertCrdnSttsHstry(Map<String, Object> params);

	/**단속 상태 이력 정보를 등록한다.
	 * @param crdnSttsHstry 단속 상태 이력
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean insert(CrdnSttsHstry crdnSttsHstry) {
		return crdnSttsHstry != null && insertCrdnSttsHstry(params().set("crdnSttsHstry", crdnSttsHstry)) == 1;
	}

	/**단속 상태 이력 정보를 수정한다.
	 * @param params 파라미터
	 * <ul><li>"crdnSttsHstry" - 단속 상태 이력</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int updateCrdnSttsHstry(Map<String, Object> params);

	/**단속 상태 이력 정보를 수정한다.
	 * @param crdnSttsHstry 단속 상태 이력
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean update(CrdnSttsHstry crdnSttsHstry) {
		return crdnSttsHstry != null && updateCrdnSttsHstry(params().set("crdnSttsHstry", crdnSttsHstry)) == 1;
	}

	/**지정한 단속 상태 이력을 삭제한다.
	 * @param params 파라미터
	 * <ul><li>"crdnSttsHstry" - 단속 상태 이력</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int deleteCrdnSttsHstry(Map<String, ?> params);

	/**단속 상태 이력 정보를 삭제한다.
	 * @param crdnSttsHstry 단속 상태 이력
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean delete(CrdnSttsHstry crdnSttsHstry) {
		return crdnSttsHstry != null && deleteCrdnSttsHstry(params().set("crdnSttsHstry", crdnSttsHstry)) == 1;
	}

	/**단속(TB_CRDN) 대장의 단속 상태 코드를 수정한다.
	 * @param params 파라미터
	 * <ul><li>"excl01" - 부과 제외 대장</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int updateCrdnSttsCd(Map<String, Object> params);

	/**단속(TB_CRDN) 대장의 단속 상태 코드를 수정한다.
	 * @param excl01 부과 제외 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean updateCrdn(CrdnSttsHstry crdnSttsHstry) {
		return crdnSttsHstry != null && updateCrdnSttsCd(params().set("crdnSttsHstry", crdnSttsHstry)) == 1;
	}

}
